#include "stdafx.h"

#include "../SDK/foobar2000.h"


using namespace std;
using namespace boost;


decltype(send) *pfn_send;

int
WSAAPI
send_hook(
		  IN SOCKET s,
		  __in_bcount(len) const char FAR * buf,
		  IN int len,
		  IN int flags
		  )
{
	if (len > 0 && buf)
	{
		string d(buf, len);

		regex rx(".*Host:[^\r]+di\\.fm\r\n.*");

		if (regex_match(d, rx))
		{
			d += "Referer: http://www.di.fm/\r\n";

			regex rx("User-Agent:[^\r]+\r\n");

			d = regex_replace(d, rx, "User-Agent: Mozilla/5.0 (Windows NT 5.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/41.0.2272.89 Safari/537.36 OPR/28.0.1750.48\r\n");

			pfn_send(s, d.c_str(), d.size(), flags);

			return len; 
		}
	}

	return pfn_send(s, buf, len, flags);
}

void splice()
{
	MH_Initialize();

	HMODULE mod = LoadLibrary(L"ws2_32");
	void * ptr = GetProcAddress(mod, "send");

	if (ptr)
	{
		MH_CreateHook(ptr, send_hook, 
			reinterpret_cast<void**>(&pfn_send));

		MH_EnableHook(ptr);
	}
}

class initquit_handler : public initquit {   
	virtual void on_init() {
		splice();
	}

	virtual void on_quit() {	

	}
};

static initquit_factory_t<initquit_handler> foo_initquit;

DECLARE_COMPONENT_VERSION("foo_di_fm", "0.1", "Plugin For di.fm");



